﻿function TRP2_SecureSendAddonMessage(Prefixe,Message,Cible)

	if Prefixe == nil then
		TRP2_debug("Prefixe nil")
		return;
	elseif Message == nil then
		TRP2_debug("Message nil")
		return;
	elseif Cible == nil then
		TRP2_debug("Cible nil")
		return;
	end
	
	if not TRP2_GetConfigValueFor("ActivateExchange",true) then
		return;
	end

	local taille = string.len(Prefixe) + string.len(Message) + 4;
	
	if taille > 254 then
		TRP2_Error("Internal Error : Tentative de TRPSecureSendAddonMessage avec une taille de "..taille.."!\nEnvoi annulé !");
		return;
	end
	SendAddonMessage("TRP2"..Prefixe,Message, "WHISPER", Cible);
end

function TRP2_SecureSendAddonMessageGroup(Prefixe,Message)

	if Prefixe == nil then
		TRP2_debug("Prefixe nil")
		return;
	elseif Message == nil then
		TRP2_debug("Message nil")
		return;
	end
	
	if not TRP2_GetConfigValueFor("ActivateExchange",true) then
		return;
	end

	local taille = string.len(Prefixe) + string.len(Message) + 4;
	
	if taille > 254 then
		TRP2_Error("Internal Error : Tentative de TRP2_SecureSendAddonMessageGroup avec une taille de "..taille.."!\nEnvoi annulé !");
		return;
	end
	if GetNumRaidMembers() > 0 then
		SendAddonMessage("TRP2"..Prefixe,Message, "RAID");
	elseif GetNumPartyMembers() > 0 then
		SendAddonMessage("TRP2"..Prefixe,Message, "PARTY");
	end
end

function TRP2_SendContentToChannel(infoTab,prefix)
	if not TRP2_GetConfigValueFor("ActivateExchange",true) then
		return;
	end
	local message = "TRP2"..TRP2_ReservedChar..prefix;
	for _,info in pairs(infoTab) do
		message = message..TRP2_ReservedChar..info;
	end
	if string.len(message) < 254 then
		SendChatMessage(message, "CHANNEL", GetDefaultLanguage("player"), GetChannelName(TRP2_GetConfigValueFor("ChannelToUse","xtensionxtooltip2")));
	else
		TRP2_Error("Internal Error : Tentative de TRP2_SendContentToChannel avec une taille de "..string.len(message).."!\nEnvoi annulé !");
	end
end

function TRP2_ReceiveMessageChannel(message,sender)
	if TRP2_EstIgnore(sender) or not TRP2_GetConfigValueFor("ActivateExchange",true) then
		return;
	end
	local messageTab = TRP2_fetchInformations(message);
	if sender == TRP2_Joueur then
		if messageTab[1] == "TRP2" and messageTab[2] == "HELLO" then
			TRP2_bAlreadyTellRSP = true;
		end
		return;
	end
	if messageTab[1] and messageTab[1] == "TRP2" and messageTab[2] then
		if messageTab[2] == "GetLocalCoord" then
			TRP2_SendCoordonnees(sender,messageTab[3],messageTab[4]);
		elseif messageTab[2] == "LocalSound" then
			TRP2_CalculateLocalSound(sender,messageTab[3],tonumber(messageTab[4]),tonumber(messageTab[5]),tonumber(messageTab[6]),tonumber(messageTab[7]),tonumber(messageTab[8]));
		elseif messageTab[2] == "HELLO" then
			if tonumber(messageTab[3]) and not TRP2_bAlreadyTell and (tonumber(messageTab[3]) > tonumber(TRP2_version)) and TRP2_GetConfigValueFor("NotifyOnNew",true) then
				TRP2_bAlreadyTell = true;
				TRP2_NewVersionDispo(tonumber(messageTab[3]));
			end
			if not TRP2_EstDansLeReg(sender) and TRP2_GetConfigValueFor("AutoNew",true) then
				TRP2_AjouterAuRegistre(sender, UnitName("target") == sender);
			end
		elseif messageTab[2] == "GetPlanque" then
			TRP2_ChanGetPlanque(sender,messageTab[3]);
		end
	end
end

function TRP2_receiveMessage(prefixe,sender,message)
	if TRP2_EstIgnore(sender) or sender == TRP2_Joueur or not TRP2_GetConfigValueFor("ActivateExchange",true) then
		return;
	end
	
	TRP2_debug(prefixe.." "..sender);

	------------------
	--- VERNUM
	------------------
	if prefixe == "GTVN" then -- GET VerNum
		-- On recoit une liste des versions, on renvoie directement sa liste des versions
		TRP2_SecureSendAddonMessage("SNVN",TRP2_SendVernNum(),sender);
		-- On traite les vernum reçu
		TRP2_ReceiveVerNumList(TRP2_fetchInformations(message),sender);
	elseif prefixe == "SNVN" then --SEND VerNum
		-- On traite les vernum reçu
		TRP2_ReceiveVerNumList(TRP2_fetchInformations(message),sender);
	------------------
	--- REGISTRE
	------------------
	elseif prefixe == "RRMI" then --REGISTRE REQUEST Info Minion
		TRP2_MinionJoueurFormatAndSend(sender);
	elseif prefixe == "RRMO" then --REGISTRE REQUEST Info Mount
		TRP2_MountJoueurFormatAndSend(sender);
	elseif prefixe == "RSMI" then --REGISTRE SENDING Info Minion
		TRP2_ReceiveMinion(message,sender);
	elseif prefixe == "RSMO" then --REGISTRE SENDING Info Mount
		TRP2_ReceiveMount(message,sender);
	------------------
	--- DIVERS
	------------------
	elseif prefixe == "SNCC" then --MAP Send Coordonnees
		TRP2_AddPlayerToMapTab(sender,TRP2_fetchInformations(message));
	elseif prefixe == "MESS" then -- Message
		local tab = TRP2_fetchInformations(message);
		TRP2_Afficher(TRP2_FT(_G[tab[1]],tab[2],tab[3],tab[4],tab[5]));
	elseif prefixe == "MERP" then -- Message RP
		TRP2_Afficher(message,TRP2_GetConfigValueFor("InvMessageFrameRP",1),true);
	elseif prefixe == "PLLS" then -- Play sound
		TRP2_PlayGroupSound(message,sender);
	------------------
	--- OBJECTS (n'importe quel tableau de données)
	------------------
	elseif prefixe == "ORIN" then --OBJET REQUEST Info
		TRP2_SendTabTo(message,TRP2_GetObjectTab(message,TRP2_Royaume,TRP2_Joueur,{},sender),sender);
	elseif prefixe == "ORSE" then --OBJET REQUEST Info
		TRP2_CheckDoIHaveInfo(TRP2_fetchInformations(message),sender);
	elseif prefixe == "OSIN" then --OBJET SEND Info
		TRP2_ReceiveTab(message,sender);
	elseif prefixe == "OSRE" then --OBJET SEND Refusal
		TRP2_RefusalTab(TRP2_fetchInformations(message),sender);
	------------------
	--- TRADE
	------------------
	elseif prefixe == "OTST" then --OBJET TRADE START
		TRP2_StartExchangeAsk(message,sender);
	elseif prefixe == "OTUP" then --OBJET TRADE UPDATE
		TRP2_ExchangeReceiveTab(message,sender);
	elseif prefixe == "OTCA" then --OBJET TRADE CANCEL
		TRP2_CancelTransactionReceive(sender);
	elseif prefixe == "OTOK" then --OBJET TRADE OK
		TRP2_OKTransactionReceive(sender);
	elseif prefixe == "COSN" then --Colis Send
		TRP2_ReceiveColis(TRP2_fetchInformations(message),sender);
	elseif prefixe == "COOK" then --Colis Send
		TRP2_ReceiveColisOK(tonumber(message),sender);
	------------------
	--- PLANQUE
	------------------
	elseif prefixe == "PLSI" then --PLANQUE send info (from owner)
		TRP2_PlanqueReceiveInfo(sender,TRP2_fetchInformations(message));
	elseif prefixe == "PLIN" then --PLANQUE init visit (from visitor)
		TRP2_PlanqueInitVisit(sender,message);
	elseif prefixe == "PLSU" then --PLANQUE send update (from owner)
		TRP2_GetUpdateFromPlanque(sender,TRP2_fetchInformations(message));
	elseif prefixe == "PLST" then --PLANQUE STOP (from owner)
		TRP2_PlanqueStop(sender,message);
	elseif prefixe == "PLRL" then --PLANQUE Release lock (from visitor)
		TRP2_PlanqueReleaseLock(sender,message);
	elseif prefixe == "PLUL" then --PLANQUE send Update (from visitor)
		TRP2_GetUpdateFromVisitor(sender,TRP2_fetchInformations(message));
	elseif prefixe == "PLLO" then --PLANQUE Log (from visitor)
		TRP2_GetPlanqueLog(sender,TRP2_fetchInformations(message));
	elseif prefixe == "PLAS" then --PLANQUE Ask (from visitor)
		TRP2_PlanqueAsk(sender,message);
	elseif prefixe == "PLOK" then --PLANQUE Ask ok (from owner)
		TRP2_PlanqueAskOk(sender);
	------------------
	--- LANGAGE
	------------------
	elseif prefixe == "LATR" then -- Demande de traduction
		TRP2_ReceiveTranslateRequest(sender,TRP2_fetchInformations(message));
	elseif prefixe == "LASN" then -- Reception de traduction
		TRP2_ReceiveTranslate(sender,TRP2_fetchInformations(message));
	end
end

-- Trouve le tableau en fonction de l'id.
function TRP2_GetObjectTab(id,royaume,nom,defaut,asking)
	-- Verif le OTY
	
	if id == "Actu" and royaume and nom then
		return TRP2_GetInfo(royaume,nom,"Actu",defaut);
	elseif id == "Registre" and royaume and nom then
		return TRP2_GetInfo(royaume,nom,"Registre",defaut);
	elseif id == "Physique" and royaume and nom then
		return TRP2_GetInfo(royaume,nom,"Physique",defaut);
	elseif id == "Histoire" and royaume and nom then
		if not asking or TRP2_GetAccess(asking) >= TRP2_GetConfigValueFor("AccessHisto",3) then
			return TRP2_GetInfo(royaume,nom,"Histoire",defaut);
		else
			local tableau = {};
			TRP2_tcopy(tableau,TRP2_GetInfo(royaume,nom,"Histoire",defaut));
			tableau["HistoireTexte"] = "\n\n\n{titre3:centre}"..TRP2_LOC_TRUSTNEEDED.."{/titre3}";
			return tableau;
		end
	elseif id == "Psycho" and royaume and nom then
		return TRP2_GetInfo(royaume,nom,"Psycho",defaut);
	end
	-- Tableaux des auras
	if id == "Auras" then
		return TRP2_FormatAuraToSend(TRP2_Joueur);
	end
	
	if string.sub(id,1,3) == "PET" then
		local petTab = TRP2_GetInfo(royaume,nom,"Pets",{});
		return TRP2_GetWithDefaut(petTab,string.sub(id,4),{});
	elseif string.sub(id,1,4) == "APET" then
		local petTab = TRP2_GetWithDefaut(TRP2_GetWithDefaut(TRP2_GetInfo(royaume,nom,"Pets",{}),string.sub(id,5),{}),"AurasTab",{});
		local auraTab = {};
		for auraID,v in pairs(petTab) do
			local info = TRP2_GetAuraInfo(auraID);
			if tonumber(TRP2_GetWithDefaut(info,"EtatCat",2)) ~= 2 then
				auraTab[auraID] = v;
			end
		end
		return auraTab;
	elseif string.sub(id,1,3) == "ITE" then
		return TRP2_GetItemInfo(id);
	elseif string.sub(id,1,3) == "AUR" then
		return TRP2_GetAuraInfo(id);
	elseif string.sub(id,1,3) == "QUE" then
		return TRP2_GetQuestsInfo(id);
	elseif string.sub(id,1,3) == "DOC" then
		return TRP2_GetDocumentInfo(id);
	end
	return defaut;
end

-- Vérifie que le tableau de synchro est existant pour cible, si pas on le créer.
function TRP2_OpenRequestTabFor(cible)
	if not TRP2_SynchronisedTab[cible] then 
		TRP2_SynchronisedTab[cible] = {};
	end
end

-- On recois un refus
function TRP2_RefusalTab(tab,sender)
	if TRP2_EmptyToNil(tab[1]) then --ID
		--TRP2_debug("REFUSAL de "..sender.." : Id "..tab[1]);
		if TRP2_SynchronisedTab[sender] and TRP2_SynchronisedTab[sender][tab[1]] then
			TRP2_SynchronisedTab[sender][tab[1]] = nil;
			TRP2_TerminerSynchroWith(sender);
		end
	end
end

-- On supprime le tableau de synchronisation avec sender si il est vide.
function TRP2_TerminerSynchroWith(sender)
	if TRP2_SynchronisedTab[sender] and TRP2_GetIndexedTabSize(TRP2_SynchronisedTab[sender]) == 0 then
		TRP2_SynchronisedTab[sender] = nil;
	end
end

-- Envoie des liaisons de création
function TRP2_FindAndGetLiaisons(tab,sender,ID)
	if string.sub(ID,1,3) == "AUR" and tonumber(TRP2_GetWithDefaut(TRP2_GetAuraInfo(ID),"EtatCat",2)) == 3 then -- Pas de liaison si état de type quête !
		return;
	end
	local stream = TRP2_TabToStream(tab);
	local IDList = TRP2_FindIDInStream(stream);
	for k,v in pairs(IDList) do
		if not TRP2_Module_Interface["BannedID"][k] and not TRP2_GetTabInfo(k) then
			TRP2_OpenRequestForObject(k,sender);
		end
	end
end

-- On traite le tableau qu'on viens de recomposer pour prendre des décisions de stockage
function TRP2_TraiterTab(id,infoTab,sender)
	-- Verif le OTY
	-- TODO : Toute les vérifications de cohérence !!!
	--TRP2_Montre(infoTab);
	if not TRP2_VerifAndFixContent(id,infoTab) then
		TRP2_debug("TRP2_TraiterTab , TRP2_VerifAndFixContent return !");
		return; -- VernNum foireux, on enregistre pas
	end
	
	if id == "Auras" then
		TRP2_SaveSendedAurasTab(sender,infoTab);
		TRP2_RefreshRegistre(sender);
	elseif id == "Actu" then
		wipe(TRP2_GetInfo(TRP2_Royaume,sender,"Actu",{}));
		TRP2_SetInfo(TRP2_Royaume,sender,"Actu",infoTab);
		TRP2_RefreshRegistre(sender);
	elseif id == "Registre" then
		wipe(TRP2_GetInfo(TRP2_Royaume,sender,"Registre",{}));
		TRP2_SetInfo(TRP2_Royaume,sender,"Registre",infoTab);
		TRP2_RefreshRegistre(sender);
	elseif id == "Physique" then
		wipe(TRP2_GetInfo(TRP2_Royaume,sender,"Physique",{}));
		TRP2_SetInfo(TRP2_Royaume,sender,"Physique",infoTab);
	elseif id == "Histoire" then
		wipe(TRP2_GetInfo(TRP2_Royaume,sender,"Histoire",{}));
		TRP2_SetInfo(TRP2_Royaume,sender,"Histoire",infoTab);
		TRP2_RefreshRegistre(sender);
	elseif id == "Psycho" then
		wipe(TRP2_GetInfo(TRP2_Royaume,sender,"Psycho",{}));
		TRP2_SetInfo(TRP2_Royaume,sender,"Psycho",infoTab);
		TRP2_RefreshRegistre(sender);
	elseif string.sub(id,1,3) == "PET" then
		local petTab = TRP2_GetInfo(TRP2_Royaume,sender,"Pets",{});
		wipe(TRP2_GetWithDefaut(petTab,string.sub(id,4),{}));
		petTab[string.sub(id,4)] = infoTab;
		TRP2_SetInfo(TRP2_Royaume,sender,"Pets",petTab);
		
		if TRP2MainFrame:IsVisible() and TRP2MainFrame.Onglet == "Pets" and TRP2MainFrame.Nom == sender then
			TRP2_OpenPanel("Fiche", "Pets", TRP2MainFrame.SousOnglet, TRP2MainFrame.Mode, TRP2MainFrame.Nom);
		end
	elseif string.sub(id,1,4) == "APET" then
		local petTab = TRP2_GetInfo(TRP2_Royaume,sender,"Pets",{});
		if not petTab[string.sub(id,5)] then petTab[string.sub(id,5)] = {}; end
		-- On ne tient pas compte de l'état si pas niveau d'accès
		local realTab = {};
		for auraID,auraVernum in pairs(infoTab) do
			if not TRP2_Module_Interface["BannedID"][auraID] and (string.len(auraID) ~= TRP2_IDSIZE or TRP2_GetAccess(sender) >= TRP2_GetConfigValueFor("EtatAccess",4)) then
				realTab[auraID] = auraVernum;
				if string.len(auraID) == TRP2_IDSIZE and TRP2_GetWithDefaut(TRP2_GetAuraInfo(auraID),"VerNum",0) < tonumber(auraVernum) then
					TRP2_OpenRequestForObject(auraID,sender);
				end
			end
		end
		-- On enregistre
		petTab[string.sub(id,5)]["AurasTab"] = realTab;
		TRP2_SetInfo(TRP2_Royaume,sender,"Pets",petTab);
		if TRP2MainFrame:IsVisible() and TRP2MainFrame.Onglet == "Pets" and TRP2MainFrame.Nom == sender then
			TRP2_OpenPanel("Fiche", "Pets", TRP2MainFrame.SousOnglet, TRP2MainFrame.Mode, TRP2MainFrame.Nom);
		end
	else
		if string.sub(id,1,3) == "ITE" then
			if TRP2_Module_ObjetsPerso[id] then wipe(TRP2_Module_ObjetsPerso[id]) end
			TRP2_Module_ObjetsPerso[id] = infoTab;
			if TRP2_CreationFrameBase:IsVisible() then
				TRP2_CreationPanel();
			end
		elseif string.sub(id,1,3) == "AUR" then
			--if TRP2_GetAccess(sender) < TRP2_GetConfigValueFor("EtatAccess",4) then
			--	return;
			--end
			if TRP2_Module_Auras[id] then wipe(TRP2_Module_Auras[id]) end
			TRP2_Module_Auras[id] = infoTab;
			if TRP2MainFrame:IsVisible() and TRP2MainFrame.Panel == "Fiche" and TRP2MainFrame.Onglet == "Pets" and TRP2MainFrame.Nom == sender then
				TRP2_OpenPanel("Fiche", "Pets", TRP2MainFrame.SousOnglet, TRP2MainFrame.Mode, sender);
			end
			if TRP2_CreationFrameBase:IsVisible() then
				TRP2_CreationPanel();
			end
			-- Check si on a l'état sur nous !
			for key,_ in pairs(TRP2_GetInfo(TRP2_Royaume,TRP2_Joueur,"AurasTab",{})) do
				if key == id then
					TRP2_IncreaseVerNumAura();
					break;
				end
			end
		elseif string.sub(id,1,3) == "DOC" then
			if TRP2_Module_Documents[id] then wipe(TRP2_Module_Documents[id]) end
			TRP2_Module_Documents[id] = infoTab;
			if TRP2_DocumentFrame:IsVisible() and TRP2_DocumentFrame.Id == id then
				TRP2_ChargerDocument(infoTab,TRP2_DocumentFrame.Page,id,bApercu);
			end
			if TRP2_CreationFrameBase:IsVisible() then
				TRP2_CreationPanel();
			end
		elseif string.sub(id,1,3) == "QUE" then
			if TRP2_Module_Quests[id] then wipe(TRP2_Module_Quests[id]) end
			TRP2_Module_Quests[id] = infoTab;
			if TRP2_CreationFrameBase:IsVisible() then
				TRP2_CreationPanel();
			end
		end
		TRP2_FindAndGetLiaisons(infoTab,sender,id);
	end
	
	if sender == UnitName("mouseover") then
		TRP2_MouseOverTooltip("mouseover");
	end
end

-- Tableau des types des variables
TRP2_REFERENCE_TAB = {
	["VerNum"] = "number";
	["Taille"] = "number";
	["Silhouette"] = "number";
	["Ethique"] = "number";
	["ChaLux"] = "number";
	["IndRen"] = "number";
	["EtapeFlag"] = "number";
	["GenEgo"] = "number";
	["SinTro"] = "number";
	["MisCru"] = "number";
	["ModVan"] = "number";
	["StatutRP"] = "number";
	["StatutXP"] = "number";
	["PiePra"] = "number";
	["RefImp"] = "number";
	["AceBon"] = "number";
	["ValCou"] = "number";
	["Qualite"] = "number";
	["Unique"] = "number";
	["Poids"] = "number";
	["Lifetime"] = "number";
	["Valeur"] = "number";
	["Cooldown"] = "number";
	["Charges"] = "number";
	["Type"] = "number";
	["DureeDefaut"] = "number";
	["Anim"] = "number";
	-- Document
	["Level"] = "number";
	["Spacing"] = "number";
	["PosX"] = "number";
	["PosY"] = "number";
	["DimX"] = "number";
	["DimY"] = "number";
	["ShadowX"] = "number";
	["ShadowY"] = "number";
	["bContours"] = "bool";
	["R"] = "number";
	["G"] = "number";
	["B"] = "number";
	["A"] = "number";
	["EtatCat"] = "number";
	["ShadowR"] = "number";
	["ShadowG"] = "number";
	["ShadowB"] = "number";
	["ShadowA"] = "number";
	["EndR"] = "number";
	["EndG"] = "number";
	["EndB"] = "number";
	["EndA"] = "number";
	["Left"] = "number";
	["Right"] = "number";
	["Top"] = "number";
	["Bottom"] = "number";
	["Desaturated"] = "bool";
	["bRound"] = "bool";
	["bReinit"] = "bool";
	-- Objets
	["DureeAnim"] = "number";
	["MaxStack"] = "number";
	["bUtilisable"] = "bool";
	["bReadLock"] = "bool";
	["bWriteLock"] = "bool";
	["bDestroyable"] = "bool";
	["bDeletable"] = "bool";
	["TimeSet"] = "bool";
	["bAjout"] = "bool";
	["bCombat"] = "bool";
	["bGivable"] = "bool";
	["bManual"] = "bool";
	["bImmobile"] = "bool";
	["AurasVerNum"] = "number";
}

-- Vérifie et converti les types de variables selon TRP2_REFERENCE_TAB
function TRP2_CheckReferenceTab(info, infoName)
	if TRP2_REFERENCE_TAB[infoName] then
		if TRP2_REFERENCE_TAB[infoName] == "number" then
			return tonumber(info);
		else
			if info == "true" then
				return true;
			else
				return false;
			end
		end
	end
	return info;
end

-- Recompose un tableau à partir de son stream
function TRP2_StreamToTab(stream,id,sender)
	--TRP2_debug("TAB DE "..id);
	local infoTab = {};
	local tempTab = stream -- lvl 1
	
	table.foreach(tempTab,function(num)
		--TRP2_debug(tempTab[num]);
		if TRP2_EmptyToNil(tempTab[num]) then
			local infoName = string.sub(tempTab[num],1,string.find(tempTab[num],"%~")-1);
			local value = string.sub(tempTab[num],string.len(infoName)+2);
			if string.find(value,"%@") then
				local tempSecondTab = TRP2_FetchToTabWithSeparator(value,"@"); -- lvl 2
				local secondTab = {};
				table.foreach(tempSecondTab,function(num2)
					if TRP2_EmptyToNil(tempSecondTab[num2]) then
						local infoName = string.sub(tempSecondTab[num2],1,string.find(tempSecondTab[num2],"%~")-1);
						local value = string.sub(tempSecondTab[num2],string.len(infoName)+2);
						
						if string.find(value,"%µ") then
							local tempThirdTab = TRP2_FetchToTabWithSeparator(value,"µ"); -- lvl 3
							local thirdTab = {};
							
							table.foreach(tempThirdTab,function(num3)
								if TRP2_EmptyToNil(tempThirdTab[num3]) then
									local infoName = string.sub(tempThirdTab[num3],1,string.find(tempThirdTab[num3],"%~")-1);
									local value = string.sub(tempThirdTab[num3],string.len(infoName)+2);
									thirdTab[infoName] = TRP2_EmptyToNil(value);
									thirdTab[infoName] = TRP2_CheckReferenceTab(thirdTab[infoName], infoName);
								end
							end);
							
							value = thirdTab;
						end
						secondTab[infoName] = TRP2_EmptyToNil(value);
						secondTab[infoName] = TRP2_CheckReferenceTab(secondTab[infoName], infoName);
					end
				end);
				value = secondTab;
			end
			infoTab[infoName] = TRP2_EmptyToNil(value);
			infoTab[infoName] = TRP2_CheckReferenceTab(infoTab[infoName], infoName);
		end
	end);
	
	return infoTab;
end

-- Recois un morceaux de stream, et recompose une fois tout le stream arrivé + traitement
function TRP2_ReceiveTab(message,sender)
	if TRP2_SynchronisedTab[sender] then
		local ID = string.sub(message,1,string.find(message,"%"..TRP2_ReservedChar)-1);
		message = string.sub(message,string.len(ID)+2);
		if TRP2_SynchronisedTab[sender][ID] then 
			--TRP2_debug(message);
			local indice = tonumber(string.sub(message,1,string.find(message,"%"..TRP2_ReservedChar)-1));
			--TRP2_debug(indice);
			if indice == 0 then
				-- Fin de transmission
				local streamTab = TRP2_SuperFetchInformations(TRP2_SynchronisedTab[sender][ID]);
				TRP2_TraiterTab(ID,TRP2_StreamToTab(streamTab,ID,sender),sender);
				wipe(TRP2_SynchronisedTab[sender][ID]);
				TRP2_SynchronisedTab[sender][ID] = nil;
				TRP2_TerminerSynchroWith(sender);
			else
				TRP2_SynchronisedTab[sender][ID][indice] = string.sub(message,string.len(indice)+2);
			end
		else
			TRP2_debug("Pas de query attendu pour cet object... "..ID);
		end
	else
		TRP2_debug("Pas que query attendu... "..sender);
	end
end

-- Cette fonction préparer la requete d'un tableau
function TRP2_OpenRequestForObject(ID,cible)
	if not TRP2_GetConfigValueFor("ActivateExchange",true) then return; end
	TRP2_OpenRequestTabFor(cible);
	if not TRP2_SynchronisedTab[cible][ID] then
		TRP2_SynchronisedTab[cible][ID] = {};
		TRP2_SecureSendAddonMessage("ORIN",ID,cible);
		--TRP2_debug("Request for "..cible.." : "..ID);
	end -- ELSE : Requete déjà en cours pour cet object
end

-- Cette fonction streamise un tableau
-- Caractères réservés : ~ # @ %
function TRP2_TabToStream(infoTab)
	local infoString = "";
	if not infoTab then return infoString end
	for infoName,infovalue in pairs(infoTab) do
		infoString = infoString..infoName.."~";
		--TRP2_debug("Var lvl 1 : "..infoName);
		if type(infovalue)=="table" then --Variable de nv 2
			for infoNameB,infoValueB in pairs(infovalue) do
				infoString = infoString..infoNameB.."~";
				--TRP2_debug("Var lvl 2 : "..infoNameB);
				if type(infoValueB)=="table" then --Variable de nv 3
					for infoNameC,infoValueC in pairs(infoValueB) do
						infoString = infoString..infoNameC.."~"..tostring(infoValueC).."µ";
						--TRP2_debug("Var lvl 3 : "..infoNameC);
					end;
				else
					infoString = infoString..tostring(infoTab[infoName][infoNameB]);
				end
				infoString = infoString.."@";
			end
		else
			infoString = infoString..tostring(infovalue);
		end
		infoString = infoString..TRP2_ReservedChar;
	end
	return infoString;
end

-- Cette fonction streamise un tableau (via TRP2_TabToStream)  et l'envoi à sender
function TRP2_SendTabTo(id,infoTab,target)
	if not id then TRP2_Error("Erreur TRP2_ObjectToSend : id \""..tostring(id).."\" inconnu"); return; end
	if not infoTab then TRP2_SecureSendAddonMessage("OSRE",id,target) return; end
	local infoString = "";
	TRP2_debug("STREAM DE "..id.." : "..tostring(infoTab));
	infoString = TRP2_TabToStream(infoTab);
	
	local taille = string.len(infoString);
	local indice = 1;
	local i = 1;
	local messTab = {};
	while indice < taille do
		local tailleMax = 240 - string.len(tostring(i)) - string.len(id);
		local morceau = string.sub(infoString,indice,indice+tailleMax);
		morceau = id..TRP2_ReservedChar..i..TRP2_ReservedChar..morceau;
		messTab[#messTab+1] = morceau;
		indice = indice + tailleMax + 1;
		i = i + 1;
	end
	messTab[#messTab+1] = id..TRP2_ReservedChar.."0"..TRP2_ReservedChar; -- Fin de transmission
	TRP2_debug("Taille stream : "..taille);
	TRP2_debug("Nbr mess : "..(#messTab));
	if #messTab > 95 then
		TRP2_Afficher(TRP2_FT(TRP2_LOC_ErreurGen_1,target,TRP2_GetWithDefaut(infoTab,"Nom",id)));
		TRP2_SecureSendAddonMessage("OSRE",id,target);
	else
		for k,morceau in pairs(messTab) do
			TRP2_SecureSendAddonMessage("OSIN",morceau,target);
		end
	end
end

------------------------
-- Envois de données
------------------------

function TRP2_DataSendingAdd(prefix,message,cible)
	tinsert(TRP2_DataSendingTab,{Cible = cible,Prefix = prefix,Message = message});
end

TRP2_DataPerSecond = 25;
TRP2_DataSendingTab = {};
function TRP2_UpdateDataSending()
	local count = TRP2_DataPerSecond;
	for messNum,messageTab in pairs(TRP2_DataSendingTab) do
		if messageTab["Cible"] and messageTab["Message"] and messageTab["Prefix"] then
			count = count - 1;
			TRP2_SecureSendAddonMessage(messageTab["Prefix"],messageTab["Message"],messageTab["Cible"]);
		end
		tremove(TRP2_DataSendingTab,1);
		if count <= 0 then
			return;
		end
	end
end

function TRP2_FindIDInStream(stream)
	--TRP2_debug(stream);
	local tab = {};
	string.gsub(stream,"ITE%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d",function(ITE)
		if not tab[ITE] then
			tab[ITE] = 0;
		end
		tab[ITE] = tab[ITE] + 1;
		return ITE;
	end);
	string.gsub(stream,"AUR%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d",function(AUR)
		if not tab[AUR] then
			tab[AUR] = 0;
		end
		tab[AUR] = tab[AUR] + 1;
		return AUR;
	end);
	string.gsub(stream,"DOC%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d",function(DOC)
		if not tab[DOC] then
			tab[DOC] = 0;
		end
		tab[DOC] = tab[DOC] + 1;
		return DOC;
	end);
	string.gsub(stream,"QUE%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d",function(QUE)
		if not tab[QUE] then
			tab[QUE] = 0;
		end
		tab[QUE] = tab[QUE] + 1;
		return QUE;
	end);
	string.gsub(stream,"LAN%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d",function(LAN)
		if not tab[LAN] then
			tab[LAN] = 0;
		end
		tab[LAN] = tab[LAN] + 1;
		return LAN;
	end);
	return tab;
end

function TRP2_Montre(tab)
	for k,v in pairs(tab) do
		print(k.." : "..tostring(v).." ( "..type(v).." )");
	end
end