﻿TRP2_ElementTab = {
    -- Single Schools
    [SCHOOL_MASK_PHYSICAL]                      = SPELL_SCHOOL0_CAP, -- 1
    [SCHOOL_MASK_HOLY]                          = DAMAGE_SCHOOL2, -- 2
    [SCHOOL_MASK_FIRE]                          = DAMAGE_SCHOOL3, -- 4
    [SCHOOL_MASK_NATURE]                        = DAMAGE_SCHOOL4, -- 8
    [SCHOOL_MASK_FROST]                         = DAMAGE_SCHOOL5, -- 16
    [SCHOOL_MASK_SHADOW]                        = DAMAGE_SCHOOL6, -- 32
    [SCHOOL_MASK_ARCANE]                        = DAMAGE_SCHOOL7, -- 64
    -- Physical and a Magical
    [SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_FIRE]   = STRING_SCHOOL_FLAMESTRIKE, -- 5
    [SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_FROST]  = STRING_SCHOOL_FROSTSTRIKE,
    [SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_ARCANE] = STRING_SCHOOL_SPELLSTRIKE,
    [SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_NATURE] = STRING_SCHOOL_STORMSTRIKE,
    [SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_SHADOW] = STRING_SCHOOL_SHADOWSTRIKE,
    [SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_HOLY]   = STRING_SCHOOL_HOLYSTRIKE,
    -- Two Magical Schools
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST]      = STRING_SCHOOL_FROSTFIRE, -- 20
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_ARCANE]     = STRING_SCHOOL_SPELLFIRE, -- 68
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_NATURE]     = STRING_SCHOOL_FIRESTORM, -- 12
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_SHADOW]     = STRING_SCHOOL_SHADOWFLAME, -- 36
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_HOLY]       = STRING_SCHOOL_HOLYFIRE, -- 6
    [SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE]    = STRING_SCHOOL_SPELLFROST,
    [SCHOOL_MASK_FROST + SCHOOL_MASK_NATURE]    = STRING_SCHOOL_FROSTSTORM,
    [SCHOOL_MASK_FROST + SCHOOL_MASK_SHADOW]    = STRING_SCHOOL_SHADOWFROST,
    [SCHOOL_MASK_FROST + SCHOOL_MASK_HOLY]      = STRING_SCHOOL_HOLYFROST,
    [SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE]   = STRING_SCHOOL_SPELLSTORM,
    [SCHOOL_MASK_ARCANE + SCHOOL_MASK_SHADOW]   = STRING_SCHOOL_SPELLSHADOW,
    [SCHOOL_MASK_ARCANE + SCHOOL_MASK_HOLY]     = STRING_SCHOOL_DIVINE,
    [SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW]   = STRING_SCHOOL_SHADOWSTORM,
    [SCHOOL_MASK_NATURE + SCHOOL_MASK_HOLY]     = STRING_SCHOOL_HOLYSTORM,
    [SCHOOL_MASK_SHADOW + SCHOOL_MASK_HOLY]     = STRING_SCHOOL_SHADOWLIGHT,
    -- Three or more schools
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_NATURE]                                                                                     = STRING_SCHOOL_ELEMENTAL, -- 28
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW]                                           = STRING_SCHOOL_CHROMATIC, -- 124
    [SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW + SCHOOL_MASK_HOLY]                        = STRING_SCHOOL_MAGIC, -- 126
    [SCHOOL_MASK_PHYSICAL + SCHOOL_MASK_FIRE + SCHOOL_MASK_FROST + SCHOOL_MASK_ARCANE + SCHOOL_MASK_NATURE + SCHOOL_MASK_SHADOW + SCHOOL_MASK_HOLY] = STRING_SCHOOL_CHAOS, -- 127
};

-- Fonction principale de gestion de l'évènement COMBAT LOG
function TRP2_GererDegats(...)
	local arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19,arg20 = ...;
	
	if TRP2_GetWithDefaut(TRP2_GetInfo(TRP2_Royaume,TRP2_Joueur,"Actu",{}),"StatutRP",2) == 2 then
		if string.find(arg2,"%_DAMAGE") and arg7 == TRP2_Joueur then
			local tab = {};
			if string.find(arg2,"SWING") then -- Dégats physiques CAC
				tab["Damage"] = arg9;
				tab["Ecole"] = arg11;
				tab["Resist"] = arg12;
				tab["Blocke"] = arg13;
				tab["Absorb"] = arg14;
				tab["Critik"] = arg15;
				tab["Glancing"] = arg16;
				tab["Crushing"] = arg17;
			elseif string.find(arg2,"RANGED") then -- Dégats physiques distance
				tab["Damage"] = arg12;
				tab["Ecole"] = arg11;
				tab["Resist"] = arg15;
				tab["Blocke"] = arg16;
				tab["Absorb"] = arg17;
				tab["Critik"] = arg18;
				tab["Glancing"] = arg19;
				tab["Crushing"] = arg20;
			elseif string.find(arg2,"SPELL") then -- Dégats physiques distance
				tab["Damage"] = arg12;
				tab["Ecole"] = arg11;
				tab["Resist"] = arg15;
				tab["Blocke"] = arg16;
				tab["Absorb"] = arg17;
				tab["Critik"] = arg18;
				tab["Glancing"] = arg19;
				tab["Crushing"] = arg20;
			elseif string.find(arg2,"ENVIRONMENTAL") then
				tab["EnvType"] = arg9;
				tab["Damage"] = arg10;
			end
			TRP2_TraiterDegatTab(tab,arg2);
		end
	end
end

-- Premier Tri entre dégat ENVI - SWING - RANGED - SPELL
function TRP2_TraiterDegatTab(tab,event)
	if event == "ENVIRONMENTAL_DAMAGE" then
		TRP2_TraiterDegatEnvironnement(tab,TRP2_CalculateGearScore())
	elseif event == "SWING_DAMAGE" then
		TRP2_TraiterTabSwing(tab,TRP2_CalculateGearScore());
	elseif event == "RANGED_DAMAGE" then
		TRP2_Afficher(event);
		TRP2_Montre(tab);
	elseif event == "SPELL_DAMAGE" then
		TRP2_TraiterSpell(tab,TRP2_CalculateGearScore());
	end
end

-- ENVI : Gestion des dégats d'environnement
function TRP2_TraiterDegatEnvironnement(tab,GearScore)
	if tab["EnvType"] == "DROWNING" then
		-- TODO: Ajouter un état : A bu la tasse !
		TRP2_Afficher("A bu la tasse !",nil,true,3);
		-- TODO: Ajouter un état : Mouillé
		TRP2_Afficher("Mouillé",nil,true,3);
	elseif tab["EnvType"] == "FALLING" then
		local ratio = (TRP2_GetWithDefaut(tab,"Damage",0)/UnitHealthMax("player")); -- Pourcent !
		TRP2_TraiterDegatChute(ratio);
	elseif tab["EnvType"] == "FIRE" or tab["EnvType"] == "LAVA" then 
		TRP2_TraiterDegatFeuLavaEnvi(tab["EnvType"],GearScore);
	elseif tab["EnvType"] == "SLIME" then
		-- TODO: Trouver une idée pour le slime
		-- un état "recouvert de slime" peut etre ? Qui s'en va quand on nage !
		TRP2_Afficher("Couvert de slime !",nil,true,3);
	end
end

-- ENVI : Dégat de chute
function TRP2_TraiterDegatChute(ratio)
	local ratioDurabilite = 0;
	if IsMounted() then
		-----------------------------------
		-- Dégats sur le coffre
		-----------------------------------
		local degatCoffre = 0
		if ratio >= 0.75 then
			degatCoffre = 4;
		elseif ratio >= 0.50 then
			degatCoffre = 3;
		elseif ratio >= 0.25 then
			degatCoffre = 2;
		elseif ratio >= 0.10 then
			degatCoffre = 1;
		end
		if degatCoffre > 0 then
			TRP2_DegatCoffre(degatCoffre,STRING_ENVIRONMENTAL_DAMAGE_FALLING);
			ratioDurabilite = TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Durabilite"] / TRP2_CoffreMonture[TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Id"]]["Resistance"];
			-- Perte d'objet en fonction de l'état
			if random(50) >= ratioDurabilite*100 then
				-- TODO: perte d'objet
				TRP2_Afficher("Perte d'un objet du coffre !",nil,true,3);
			end
			if random(50) >= ratioDurabilite*100 then
				local quantity = ceil((TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Or"]/10)*ratio);
				if quantity > 0 then
					-- TODO: enregistrement de l'endroit
					TRP2_InvDelGold("Coffre",quantity,false);
					TRP2_Afficher(TRP2_FT("{j}Vous avez perdu {w}%1{j} du coffre dans votre chute.",TRP2_GoldToText(quantity)));
					TRP2_PlaySound("Sound\\Interface\\LootCoinLarge.wav");
				end
			end
		end
		-- TODO: blessure de la monture
	else
		-----------------------------------
		-- Dégats sur le sac
		-----------------------------------
		local degatCoffre = 1;
		if ratio >= 0.75 then
			degatCoffre = 4;
		elseif ratio >= 0.50 then
			degatCoffre = 3;
		elseif ratio >= 0.25 then
			degatCoffre = 2;
		end
		TRP2_DegatSac(degatCoffre,STRING_ENVIRONMENTAL_DAMAGE_FALLING);
		ratioDurabilite = TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Durabilite"] / TRP2_SacsADos[TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Id"]]["Resistance"];
		if random(50) >= ratioDurabilite*100 then
			-- TODO: perte d'objet
			TRP2_Afficher("Perte d'un objet du sac ! "..ratioDurabilite,nil,true,3);
		end
		if random(50) >= ratioDurabilite*100 then
			local quantity = ceil((TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Or"]/10)*ratio);
			if quantity > 0 then
				-- TODO: enregistrement de l'endroit
				TRP2_InvDelGold("Sac",quantity,false);
				TRP2_Afficher(TRP2_FT("{j}Vous avez perdu {w}%1{j} du sac dans votre chute.",TRP2_GoldToText(quantity)));
				TRP2_PlaySound("Sound\\Interface\\iMoneyDialogClose.wav");
			end
		end
		-----------------------------------
		-- Dégats sur le perso
		-----------------------------------
		local typeBlessure = 0; -- 1 = Hema, 2 = Entorse, 3 = Déchirure, 4 = Fracture, 5 = Fracture ouverte
		if ratio >= 0.75 and ratio < 1 then -- de 75% à la presque mort (rien si mort)
			local rand = random(10);
			if rand == 1 then -- Entorse : 10%
				typeBlessure = 2;
			elseif rand <= 4 then -- Déchirure : 30%
				typeBlessure = 3;
			elseif rand <= 8 then -- Fracture : 40%
				typeBlessure = 4;
			elseif rand <= 10 then -- Fracture ouverte : 20%
				typeBlessure = 5;
			end
		elseif ratio >= 0.50 then -- de 50% à 75%
			local rand = random(10);
			if rand <= 3 then -- Entorse : 30%
				typeBlessure = 2;
			elseif rand <= 7 then -- Déchirure : 40%
				typeBlessure = 3;
			elseif rand <= 9 then -- Fracture : 20%
				typeBlessure = 4;
			elseif rand == 10 then -- Fracture ouverte : 10%
				typeBlessure = 5;
			end
		elseif ratio >= 0.25 then -- de 25% à 50%
			local rand = random(10);
			if rand <= 2 then -- Entorse : 20%
				typeBlessure = 2;
			elseif rand <= 6 then -- Déchirure : 40%
				typeBlessure = 3;
			elseif rand <= 10 then -- Fracture : 40%
				typeBlessure = 4;
			end
		elseif ratio >= 0.10 then -- de 10% à 25%
			local rand = random(10); -- 20% de chance de rien avoir
			if rand <= 2 then -- Hématome : 20%
				typeBlessure = 1;
			elseif rand <= 6 then -- Entorse : 40%
				typeBlessure = 2;
			elseif rand <= 8 then -- Déchirure : 20%
				typeBlessure = 3;
			end
		else -- De 0% à 10%
			local rand = random(10); -- 40% de chance de rien avoir
			if rand <= 4 then -- Hématome : 40%
				typeBlessure = 1;
			elseif rand <= 6 then -- Entorse : 20%
				typeBlessure = 2;
			end
		end
		-- Traitement de la blessure
		if typeBlessure ~= 0 then
			if typeBlessure == 1 then -- Hématôme
				TRP2_GetBlessure(STRING_ENVIRONMENTAL_DAMAGE_FALLING,TRP2_HEMATOMETAB,TRP2_HEMATOMESound,86000);
			elseif typeBlessure == 2 then -- Entorse
				TRP2_Afficher(TRP2_FOULURETAB[random(#TRP2_FOULURETAB)],nil,true,3);
			elseif typeBlessure == 3 then -- Déchirure
				TRP2_Afficher(TRP2_DECHIRURETAB[random(#TRP2_DECHIRURETAB)],nil,true,3);
			elseif typeBlessure == 4 then -- Fracture
				TRP2_Afficher(TRP2_FRACTURETAB[random(#TRP2_FRACTURETAB)],nil,true,3);
			elseif typeBlessure == 5 then -- Fracture ouverte
				TRP2_Afficher(TRP2_FRACTUREOTAB[random(#TRP2_FRACTUREOTAB)],nil,true,3);
			end
		end
	end
end

-- ENVI : Dégat de feu/lave
function TRP2_TraiterDegatFeuLavaEnvi(EnvType,GearScore)
	local degatSacCoffre = random(4); -- Dégat automatique ! Faut pas sauter dans le feu, on vous le dit depuis votre enfance ...
	if EnvType == "LAVA" then degatSacCoffre = degatSacCoffre*2 end -- La lave double les dégâts !
	if IsMounted() then -- Dégats monture
		TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Durabilite"] = max(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Durabilite"] - degatSacCoffre,0);
		TRP2_Afficher(TRP2_FT(TRP2_LOC_REA_COFFDAMAGE,degatSacCoffre,_G["STRING_ENVIRONMENTAL_DAMAGE_"..EnvType]));
		-- Brûlure
		if random(2) == 2 then
			-- TODO: brulure monture
			TRP2_Afficher("Brulure de la monture !",nil,true,3);
		end
	else -- Dégats perso
		TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Durabilite"] = max(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Durabilite"] - degatSacCoffre,0);
		TRP2_Afficher(TRP2_FT(TRP2_LOC_REA_BAGDAMAGE,degatSacCoffre,_G["STRING_ENVIRONMENTAL_DAMAGE_"..EnvType]));
		-- Brûlure
		if random(38) > TRP2_CalculateGearScore() then
			-- TODO: brulure perso
			TRP2_Afficher(TRP2_BRULURETAB[random(#TRP2_BRULURETAB)],nil,true,3);
		end
	end
	-- Ensuite petit test plus vicieux pour voir si on prend feu
	if EnvType == "LAVA" or GearScore < random(17) then
		-- TODO: Refaire l'état "Personnage en feu"
		TRP2_Afficher("Vous prennez feu !",nil,true,3);
	end
end

-- SWING : Dégats physiques
function TRP2_TraiterTabSwing(tab,gearscore)
	if not tab["Absorb"] and not tab["Resist"] and not tab["Blocke"] then -- Pour rappel, si on semi-resist/bloque ...etc on ne se prends rien.
		local ratio = TRP2_GetInfo(TRP2_Royaume,TRP2_Joueur,"RealDiff",0.25);
		if IsMounted() then
			-- Coffre
			if random(5) == 5*ratio then
				TRP2_DegatCoffre(degatCoffre,SPELL_SCHOOL0_CAP);
			end
			-- Blessure monture
			if random(5) == 5 then
				-- TODO: Blessures monture
				TRP2_Afficher("Blessure monture",nil,true,3);
			end
		else
			-- Dégats Sac
			local randomSac = 5*ratio;
			if gearscore > 28 then
				randomSac = 160*ratio;
			elseif gearscore > 24 then
				randomSac = 80*ratio;
			elseif gearscore > 20 then
				randomSac = 40*ratio;
			elseif gearscore > 14 then
				randomSac = 20*ratio;
			elseif gearscore > 8 then
				randomSac = 10*ratio;
			end
			if random(ceil(randomSac)) == 1 then
				TRP2_DegatSac(1,SPELL_SCHOOL0_CAP);
			end
			-- Blessure perso
			local randomBlessure = 5*ratio;
			if gearscore > 28 then
				randomBlessure = 160*ratio;
			elseif gearscore > 24 then
				randomBlessure = 80*ratio;
			elseif gearscore > 20 then
				randomBlessure = 40*ratio;
			elseif gearscore > 14 then
				randomBlessure = 20*ratio;
			elseif gearscore > 8 then
				randomBlessure = 10*ratio;
			end
			if random(ceil(randomBlessure)) == 1 then
				local blessureType = random(100);
				if blessureType >= 97 then
					TRP2_GetBlessure(SPELL_SCHOOL0_CAP,TRP2_FRACTURETAB,TRP2_FractureSound,604800); -- 4%
				elseif blessureType >= 75 then
					TRP2_GetBlessure(SPELL_SCHOOL0_CAP,TRP2_PLAIEPROFTAB,TRP2_PlaieProfSound,18000); -- 21%
					if rand(3) == 1 then
						TRP2_GetHemmoragie();
					end
				elseif blessureType >= 50 then
					TRP2_GetBlessure(SPELL_SCHOOL0_CAP,TRP2_PLAIETAB,TRP2_PlaieSound,43000); -- 25%
				else
					TRP2_GetBlessure(SPELL_SCHOOL0_CAP,TRP2_HEMATOMETAB,TRP2_HEMATOMESound,86000); -- 50%
				end
			end
		end
	end
end

-- SPELL : Dégats magiques
function TRP2_TraiterSpell(tab,gearscore)
	if not tab["Absorb"] and not tab["Resist"] and not tab["Blocke"] then -- Pour rappel, si on semi-resist/bloque ...etc on ne se prends rien.
		if IsMounted() then
			-- Coffre
			if random(2) == 1 then
				TRP2_DegatCoffre(degatCoffre,TRP2_ElementTab[tab["Ecole"]]);
			end
			-- Blessure monture
			if random(5) == 1 then
				-- TODO: Blessures monture
				TRP2_Afficher("Blessure monture",nil,true,3);
			end
		else
			-- Dégats Sac
			local randomSac = 1;
			if gearscore > 28 then
				randomSac = 32;
			elseif gearscore > 24 then
				randomSac = 16;
			elseif gearscore > 20 then
				randomSac = 8;
			elseif gearscore > 14 then
				randomSac = 4;
			elseif gearscore > 8 then
				randomSac = 2;
			end
			if random(randomSac) == 1 then
				TRP2_DegatSac(1,TRP2_ElementTab[tab["Ecole"]]);
			end
			-- Blessure perso
			local randomBlessure = 1;
			if gearscore > 28 then
				randomBlessure = 32;
			elseif gearscore > 24 then
				randomBlessure = 16;
			elseif gearscore > 20 then
				randomBlessure = 8;
			elseif gearscore > 14 then
				randomBlessure = 4;
			elseif gearscore > 8 then
				randomBlessure = 2;
			end
			if random(randomBlessure) == 1 then
				if TRP2_ContainsMagic(tab["Ecole"],SCHOOL_MASK_FIRE) then
					TRP2_Afficher(TRP2_BRULURETAB[random(#TRP2_BRULURETAB)],nil,true,3);
				elseif TRP2_ContainsMagic(tab["Ecole"],SCHOOL_MASK_FROST) then
					TRP2_Afficher(TRP2_GELTAB[random(#TRP2_GELTAB)],nil,true,3);
				end
			end
			-- Effets spéciaux
			if tab["Critik"] then
				if TRP2_ContainsMagic(tab["Ecole"],SCHOOL_MASK_FIRE) then
					TRP2_Afficher("Critique feu !",nil,true,3);
				elseif TRP2_ContainsMagic(tab["Ecole"],SCHOOL_MASK_FROST) then
					TRP2_Afficher("Critique givre !",nil,true,3);
				end
			end
		end
	end
end

-- SPELL : Détection du type de magie dans le masque
function TRP2_ContainsMagic(damType,mask)
	if bit.band(damType,mask) ~= 0 then
		return true;
	end
	return false;
end

-- Fonction de prise d'une blessure
function TRP2_GetBlessure(from,tab,soundTab,duration)
	local blessureID;
	local auraTab = TRP2_GetInfo(TRP2_Royaume,TRP2_Joueur,"AurasTab",{});
	if TRP2_GetIndexedTabSize(auraTab) < 15 then
		local i=1;
		while i <= #tab do
			blessureID = tab[random(#tab)];
			if not auraTab[blessureID] then
				break;
			end
			i = i+1;
		end
		if i ~= #tab + 1 then
			TRP2_AddAura(blessureID,duration+random(duration/2));
			TRP2_Afficher(TRP2_FT(TRP2_REA_NewWound,TRP2_DB_Auras[blessureID]["Nom"],from),TRP2_GetConfigValueFor("InvMessageFrameRP",1),true);
			if TRP2_GetConfigValueFor("RealistePartage", true) then
				TRP2_PlayEmoteBlessure(from);
				TRP2_PlayLocalSound(soundTab[random(#soundTab)],13);
			else
				TRP2_PlaySound(soundTab[random(#soundTab)]);
			end
			TRP2_PersoCrier();
		end
	end
end

function TRP2_GetHemmoragie()
	local auraTab = TRP2_GetInfo(TRP2_Royaume,TRP2_Joueur,"AurasTab",{});
	if not auraTab["AUR10043"] then
		TRP2_AddAura("AUR10043",0);
		TRP2_Afficher(TRP2_FT(TRP2_REA_NewWound,TRP2_DB_Auras["AUR10043"]["Nom"],SPELL_SCHOOL0_CAP),TRP2_GetConfigValueFor("InvMessageFrameRP",1),true);
	end
end

TRP2_PLAIEPROFTAB = { -- 6
	"AUR10037",
	"AUR10038",
	"AUR10039",
	"AUR10040",
	"AUR10041",
	"AUR10042",
};

TRP2_PLAIETAB = { -- 6
	"AUR10031",
	"AUR10032",
	"AUR10033",
	"AUR10034",
	"AUR10035",
	"AUR10036",
};

TRP2_GELTAB = { -- 3
	"Engelure",
	"Gelure légère",
	"Gelure grave",
};

TRP2_BRULURETAB = { -- 7
	"Brûlure au bras",
	"Brûlure au visage",
	"Brûlure à la fesse",
	"Brûlure à la jambe",
	"Brûlure à la main",
	"Brûlure au torse",
	"Brûlure dans le dos",
};

TRP2_FRACTUREOTAB = { -- 5
	"Fracture ouverte du tibia",
	"Fracture ouverte de la rotule",
	"Fracture ouverte de la côte",
	"Fracture ouverte du bras",
	"Fracture ouverte de la clavicule",
};

TRP2_FRACTURETAB = { -- 7
	"AUR10051",
	"AUR10052",
	"AUR10053",
	"AUR10054",
	"AUR10055",
	"AUR10056",
	"AUR10057",
};

TRP2_DECHIRURETAB = { -- 5
	"Déchirure musculaire au pied",
	"Déchirure musculaire à la main",
	"Déchirure musculaire à la jambe",
	"Déchirure musculaire au bras",
	"Déchirure musculaire intercostale",
};

TRP2_FOULURETAB = { -- 4
	"Entorse à la main gauche",
	"Entorse à la main droite",
	"Entorse au pied gauche",
	"Entorse au pied droit",
};

TRP2_HEMATOMETAB = { -- 6
	"AUR10000",
	"AUR10001",
	"AUR10002",
	"AUR10003",
	"AUR10004",
	"AUR10005",
};

TRP2_HEMATOMESound = {
	"Sound\\Item\\Weapons\\Unarmed\\UnarmedAttackSmallA.wav",
	"Sound\\Item\\Weapons\\Unarmed\\UnarmedAttackSmallB.wav",
	"Sound\\Item\\Weapons\\Unarmed\\UnarmedAttackSmallC.wav",
	"Sound\\Item\\Weapons\\Unarmed\\UnarmedAttackSmallCrit.wav",
};

TRP2_PlaieSound = {
	"Sound\\Item\\Weapons\\Dagger\\1hDaggerHitFleshA.wav",
	"Sound\\Item\\Weapons\\Dagger\\1hDaggerHitFleshB.wav",
	"Sound\\Item\\Weapons\\Dagger\\1hDaggerHitFleshC.wav",
};

TRP2_PlaieProfSound = {
	"Sound\\Item\\Weapons\\Dagger\\1hDaggerHitFleshCriticalA.wav",
};

TRP2_FractureSound = {
	"Sound\\Doodad\\SC_BoneArm_01a.wav",
	"Sound\\Doodad\\SC_BoneArm_01b.wav",
	"Sound\\Doodad\\SC_BoneArm_01c.wav",
	"Sound\\Doodad\\SC_BoneArm_01d.wav",
	"Sound\\Doodad\\SC_BoneArm_01e.wav",
};

function TRP2_PersoCrier()
	local voix = 1;
	if TRP2_PersoCri[voix] then
		if TRP2_GetConfigValueFor("RealistePartage", true) then
			TRP2_PlayLocalSound(TRP2_PersoCri[voix][#TRP2_PersoCri[voix]],13);
		else
			TRP2_PlaySound(TRP2_PersoCri[voix][#TRP2_PersoCri[voix]]);
		end
	end
end

function TRP2_PlayEmoteBlessure(from)
	if from == STRING_ENVIRONMENTAL_DAMAGE_FALLING then
		SendChatMessage("se blesse dans sa chute.","EMOTE");
	elseif from == SPELL_SCHOOL0_CAP then
		SendChatMessage("prend un coup.","EMOTE");
	end
end

TRP2_PersoCri = {
	{ -- 1 : Pirate humain
		"Sound\\Character\\Human\\MaleNPC\\HumanMalePirate\\HumanMalePirateWoundA.wav",
		"Sound\\Character\\Human\\MaleNPC\\HumanMalePirate\\HumanMalePirateWoundB.wav",
		"Sound\\Character\\Human\\MaleNPC\\HumanMalePirate\\HumanMalePirateWoundC.wav",
		"Sound\\Character\\Human\\MaleNPC\\HumanMalePirate\\HumanMalePirateWoundCrit.wav",
	},
};

TRP2_REALSoundTab = {
	["Coffre"] = {
		"Sound\\Spells\\ShieldBreak.wav",
		"Sound\\Item\\Weapons\\Shields\\WoodenShieldBlock1.wav",
		"Sound\\Item\\Weapons\\Shields\\WoodenShieldBlock2.wav",
		"Sound\\Item\\Weapons\\Shields\\WoodenShieldBlock3.wav",
		"Sound\\Item\\Weapons\\Axe2H\\m2hAxeHitWood1A.wav",
		"Sound\\Item\\Weapons\\Axe2H\\m2hAxeHitWood1B.wav",
		"Sound\\Item\\Weapons\\Axe2H\\m2hAxeHitWood1C.wav",
		"Sound\\Item\\Weapons\\Axe2H\\m2hAxeHitWood1CritA.wav",
	},
	["Sac"] = {
		"Sound\\Spells\\Tradeskills\\ArmorCraftingA.wav",
		"Sound\\Spells\\Tradeskills\\ArmorCraftingB.wav",
		"Sound\\Spells\\Tradeskills\\ArmorCraftingC.wav",
	},
}

function TRP2_DegatCoffre(degatCoffre,typeDegat)
	if TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Durabilite"] ~= 0 then
		TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Durabilite"] = max(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Coffre"]["Durabilite"] - degatCoffre,0);
		TRP2_Afficher(TRP2_FT(TRP2_LOC_REA_COFFDAMAGE,degatCoffre,typeDegat));
		TRP2_PlaySound(TRP2_REALSoundTab["Coffre"][random(#TRP2_REALSoundTab["Coffre"])]);
	end
end

function TRP2_DegatSac(degatCoffre,typeDegat)
	if TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Durabilite"] ~= 0 then
		TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Durabilite"] = max(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Sac"]["Durabilite"] - degatCoffre,0);
		TRP2_Afficher(TRP2_FT(TRP2_LOC_REA_BAGDAMAGE,degatCoffre,typeDegat));
		TRP2_PlaySound(TRP2_REALSoundTab["Sac"][random(#TRP2_REALSoundTab["Sac"])]);
	end
end

TRP2_GearLook = {1,3,5,6,7,8,9,10};
-- Full Tissu : 8
-- Full Cuir : 16
-- Full Maille : 24
-- Full Plaque : 32
function TRP2_CalculateGearScore()
	local total = 0;
	if UnitLevel("player") <= 10 then
		return 16;
	end
	for _,v in pairs(TRP2_GearLook) do
		local itemID = GetInventoryItemID("player", v);
		if itemID then
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType = GetItemInfo(itemID);
			if itemSubType == "Tissu" or itemType == "Cloth" then
				total = total + 1;
			elseif itemSubType == "Cuir" or itemType == "Leather" then
				total = total + 2;
			elseif itemSubType == "Maille" or itemType == "Mail" then
				total = total + 3;
			elseif itemSubType == "Plaque" or itemType == "Plate" then
				total = total + 4;
			end
		end
	end
	return total;
end

function TRP2_UpdateRealiste()
	if TRP2_GetWithDefaut(TRP2_GetInfo(TRP2_Royaume,TRP2_Joueur,"Actu",{}),"StatutRP",2) == 2 then
		if IsSwimming() then
			if not TRP2_PlayerHasAura("AUR00905") then
				TRP2_AddAura("AUR00905",600,true);
				--TRP2_PlaySound("Sound\\Effects\\DeathImpacts\\InWater\\mDeathImpactGiantWaterA.wav");
			else
				TRP2_SetAuraTime("AUR00905",600);
			end
		end
	end
end