﻿--**--**--**--**--**--**--**--
-- Nouveau système TRP 2 :
--**--**--**--**--**--**--**--

-- Génère un identifiant de planque sur base de coordonnée TRP2.
function TRP2_GetPlanqueID(force)
	-- Sécurité : indisponible si Carte ouverte !!!
	if TRP2_GetConfigValueFor("bDontUseCoord",false) or (TRP2_GetWorldMap():IsVisible() and not force) or not GetCurrentMapContinent() or GetCurrentMapContinent() < 1 then
		return nil;
	end
	SetMapToCurrentZone();
	local x,y = GetPlayerMapPosition("player");
	x = math.floor(x * TRP2_PrecisionPlanque);
	y = math.floor(y * TRP2_PrecisionPlanque);
	local zoneNum = TRP2_GetCurrentMapZone();
	local continentNum = GetCurrentMapContinent();
	
	return tostring(continentNum).." "..tostring(zoneNum).." "..tostring(x).." "..tostring(y);
end

function TRP2_CanPlanqueHere(force)
	-- Sécurité : indisponible si Carte ouverte !!!
	if TRP2_GetConfigValueFor("bDontUseCoord",false) or (TRP2_GetWorldMap():IsVisible() and not force) then
		return nil;
	end
	-- Si l'icone n'est pas prévue, c'est qu'on peut pas ! Et toc.
	return (TRP2_IconeZone[GetCurrentMapContinent()] and TRP2_IconeZone[GetCurrentMapContinent()][TRP2_GetCurrentMapZone()]);
end

-- Détection d'une planque
function TRP2_DetectPlanque(force)
	-- Sécurité : indisponible si Carte ouverte !!!
	if TRP2_GetConfigValueFor("bDontUseCoord",false) or (TRP2_GetWorldMap():IsVisible() and not force) or not TRP2_CanPlanqueHere(force) then
		return nil;
	end
	if TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][TRP2_GetPlanqueID(force)] then
		return true;
	else
		return false;
	end
end

-- Détection d'une planque
function TRP2_DetectAndGetPlanque(force)
	-- Sécurité : indisponible si Carte ouverte !!!
	if TRP2_GetConfigValueFor("bDontUseCoord",false) or (TRP2_GetWorldMap():IsVisible() and not force) or not TRP2_CanPlanqueHere(force) then
		return nil;
	end
	return TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][TRP2_GetPlanqueID(force)];
end

--Delete planque
function TRP2_DeletePlanque(fonction)
	if TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][TRP2InventaireFramePlanque.planqueID] then
		StaticPopupDialogs["TRP2_CONFIRM_ACTION_NS"].text = TRP2_CTS(TRP2_ENTETE..TRP2_LOC_DELPLANQUETT);
		TRP2_ShowStaticPopup("TRP2_CONFIRM_ACTION_NS",nil,function()
			TRP2_Afficher("{j}"..TRP2_FT(TRP2_LOC_DELETE_PLANQUE,"{o}"..TRP2_GetWithDefaut(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][TRP2InventaireFramePlanque.planqueID],"Nom",TRP2_LOC_NEWPLANQUE).."{j}"));
			wipe(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][TRP2InventaireFramePlanque.planqueID]);
			TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][TRP2InventaireFramePlanque.planqueID] = nil;
			if fonction then
				fonction();
			end
		end);
	end
end

--Edit planque
function TRP2_EditPlanque(fonction)
	local planqueTab = {};
	TRP2InventaireFramePlanque:Hide();
	TRP2_CreationPlanqueFrameTitle:SetText(TRP2_CTS("{w}"..TRP2_LOC_MODIFPLANQUE));
	TRP2_tcopy(planqueTab,TRP2InventaireFramePlanque.planqueTab);
	TRP2_CreationPlanqueFrame:Show();
	TRP2_CreationPlanqueFrameNom:SetText(TRP2_GetWithDefaut(planqueTab,"Nom",TRP2_LOC_NEWPLANQUE));
	TRP2_CreationPlanqueFrameAccessNomsScrollEditBox:SetText(TRP2_GetWithDefaut(planqueTab,"AccessNom",""));
	TRP2_CreationPlanqueFrameAccessLevel.Value = TRP2_GetWithDefaut(planqueTab,"Access",3);
	TRP2_CreationPlanqueFrameAccessLevelValeur:SetText(TRP2_LOC_AccessTab[TRP2_GetWithDefaut(planqueTab,"Access",3)]);
	TRP2_CreationPlanqueFrameIconeIcon:SetTexture("Interface\\ICONS\\"..TRP2_GetWithDefaut(planqueTab,"Icone","Temp"));
	TRP2_CreationPlanqueFrameIcone.icone = TRP2_GetWithDefaut(planqueTab,"Icone","Temp");
	TRP2_CreationPlanqueFrameSave:SetScript("OnClick",function()
		planqueTab["Nom"] = TRP2_EmptyToNil(TRP2_CreationPlanqueFrameNom:GetText());
		planqueTab["AccessNom"] = TRP2_EmptyToNil(TRP2_CreationPlanqueFrameAccessNomsScrollEditBox:GetText());
		planqueTab["Icone"] = TRP2_DefautToNil(TRP2_EmptyToNil(TRP2_CreationPlanqueFrameIcone.icone),"Temp");
		planqueTab["Access"] = TRP2_DefautToNil(TRP2_CreationPlanqueFrameAccessLevel.Value,3);
		TRP2_CreerPlanque(TRP2_GetWithDefaut(planqueTab,"Nom",TRP2_LOC_NEWPLANQUE),planqueTab,TRP2InventaireFramePlanque.planqueID,true);
		TRP2_CreationPlanqueFrame:Hide();
		if fonction then
			fonction();
		end
	end);
end

-- Création d'un planque : étape 1
function TRP2_ConstructPlanque()
	TRP2_SearchPlanqueListe:Hide();
	SetMapToCurrentZone();
	local zoneNum = TRP2_GetCurrentMapZone();
	local continentNum = GetCurrentMapContinent();
	local continent = { GetMapContinents() };
	local x,y = GetPlayerMapPosition("player");
	x = math.floor(x * TRP2_PrecisionPlanque);
	y = math.floor(y * TRP2_PrecisionPlanque);
	local ID = tostring(continentNum).." "..tostring(zoneNum).." "..tostring(x).." "..tostring(y);
	
	if TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][ID] then
		TRP2_Error(TRP2_LOC_ALREADY_PLANQUE);
	elseif not TRP2_CanPlanqueHere(true) then
		TRP2_Error(TRP2_LOC_CANTPLANQUEHERE);
	else
		local planqueTab = {};
		TRP2_CreationPlanqueFrameTitle:SetText(TRP2_CTS("{w}"..TRP2_LOC_CREATEPLANQUE));
		planqueTab["Continent"] = continent[continentNum];
		planqueTab["Zone"] = GetZoneText();
		planqueTab["SousZone"] = GetSubZoneText();
		planqueTab["ContinentNum"] = continentNum;
		planqueTab["ZoneNum"] = zoneNum;
		planqueTab["Or"] = 0;
		planqueTab["CoordX"] = x;
		planqueTab["CoordY"] = y;
		planqueTab["Slot"] = {};
		if TRP2_IconeZone[continentNum] and TRP2_IconeZone[continentNum][zoneNum] then
			planqueTab["Icone"] = TRP2_IconeZone[continentNum][zoneNum];
		else
			planqueTab["Icone"] = "Temp";
		end
		TRP2_CreationPlanqueFrame:Show();
		TRP2_CreationPlanqueFrameNom:SetText(TRP2_LOC_NEWPLANQUE);
		TRP2_CreationPlanqueFrameAccessNomsScrollEditBox:SetText("");
		TRP2_CreationPlanqueFrameAccessLevel.Value = 3;
		TRP2_CreationPlanqueFrameAccessLevelValeur:SetText(TRP2_LOC_AccessTab[3]);
		TRP2_CreationPlanqueFrameIconeIcon:SetTexture("Interface\\ICONS\\"..planqueTab["Icone"]);
		TRP2_CreationPlanqueFrameIcone.icone = planqueTab["Icone"];
		TRP2_CreationPlanqueFrameSave:SetScript("OnClick",function()
			planqueTab["Nom"] = TRP2_EmptyToNil(TRP2_CreationPlanqueFrameNom:GetText());
			planqueTab["AccessNom"] = TRP2_EmptyToNil(TRP2_CreationPlanqueFrameAccessNomsScrollEditBox:GetText());
			planqueTab["Icone"] = TRP2_DefautToNil(TRP2_EmptyToNil(TRP2_CreationPlanqueFrameIcone.icone),"Temp");
			planqueTab["Access"] = TRP2_DefautToNil(TRP2_CreationPlanqueFrameAccessLevel.Value,3);
			TRP2_CreerPlanque(TRP2_GetWithDefaut(planqueTab,"Nom",TRP2_LOC_NEWPLANQUE),planqueTab,ID);
			TRP2_CreationPlanqueFrame:Hide();
		end);
	end
end

-- Dropdown access
function TRP2_DD_PlanqueAccess(frame,level,menuList)
	UIDropDownMenu_SetWidth(frame, 50);
	UIDropDownMenu_SetButtonWidth(frame, 15);
	info = TRP2_CreateSimpleDDButton();
	info.text = TRP2_LOC_AccessLevel;
	info.func = function() end;
	info.isTitle = true;
	UIDropDownMenu_AddButton(info);
	
	local access = TRP2_CreationPlanqueFrameAccessLevel.Value;
	
	local i;
	for i=1,5,1 do
		info = TRP2_CreateSimpleDDButton();
		if access == i then
			info.text = TRP2_LOC_AccessTab[i];
			info.checked = true;
			info.disabled = true;
		else
			info.text = TRP2_LOC_AccessTab[i];
		end
		info.func = function() 
			TRP2_CreationPlanqueFrameAccessLevel.Value = i;
			TRP2_CreationPlanqueFrameAccessLevelValeur:SetText(TRP2_LOC_AccessTab[i]);
		end;
		UIDropDownMenu_AddButton(info,level);
	end
	info = TRP2_CreateSimpleDDButton();
	info.text = CANCEL;
	UIDropDownMenu_AddButton(info,level);
end

-- Création d'un planque : étape 2, finition
function TRP2_CreerPlanque(Nom,planqueTab,ID,bEdit)
	if planqueTab then
		TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][ID] = {};
		TRP2_tcopy(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][ID],planqueTab);
		if bEdit then
			TRP2_Afficher("{j}"..TRP2_FT(TRP2_LOC_MODIF_PLANQUE,"{o}"..TRP2_GetWithDefaut(planqueTab,"Nom",TRP2_LOC_NEWPLANQUE).."{j}"));
		else
			TRP2_Afficher("{j}"..TRP2_FT(TRP2_LOC_CREATE_PLANQUE,"{o}"..TRP2_GetWithDefaut(planqueTab,"Nom",TRP2_LOC_NEWPLANQUE).."{j}"));
		end
		if TRP2_GetPlanqueID(true) == ID then
			TRP2_ShowPlanque(TRP2_Joueur,ID);
		end
	end
end

-- Montre planque
function TRP2_ShowPlanque(Nom,planqueID)
	if not Nom or not planqueID or TRP2_GetPlanqueID(true) ~= planqueID then
		TRP2InventaireFramePlanque:Hide();
		return;
	end
	
	local planque;
	if Nom == TRP2_Joueur then
		planque = TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][planqueID];
		TRP2PlanqueFrameEdit:Show();
	elseif TRP2_Planques[Nom] and TRP2_Planques[Nom]["ID"] == planqueID then
		planque = TRP2_Planques[Nom];
		TRP2PlanqueFrameEdit:Hide();
	else
		return;
	end
	if not planque then 
		TRP2InventaireFramePlanque:Hide();
		return;
	end
	if TRP2_PlanquesLocks[planqueID] then
		TRP2_SecureSendAddonMessage("PLST",planqueID,TRP2_PlanquesLocks[planqueID]);
		TRP2_PlanquesLocks[planqueID] = nil;
	end
	TRP2_SearchPlanqueListe:Hide();
	TRP2_CreationPlanqueFrame:Hide();
	-- Icone, Nom et Or
	SetPortraitToTexture(TRP2InventaireFramePlanquePortrait,"Interface\\ICONS\\"..TRP2_GetWithDefaut(planque,"Icone","Temp"));
	TRP2InventaireFramePlanqueNomText:SetText(TRP2_CTS("{w}"..TRP2_GetWithDefaut(planque,"Nom",TRP2_LOC_NEWPLANQUE)));
	TRP2_PlanqueGoldText:SetText(TRP2_CTS("{w}"..TRP2_GoldToText(TRP2_GetWithDefaut(planque,"Or",0))));
	-- Initialisation des slots
	for slot=1,4,1 do
		local slotFrame = getglobal("TRP2PlanqueFrameSlot"..slot);
		local slotFrameIcon = getglobal(slotFrame:GetName().."Icon");
		local slotFrameQte = getglobal(slotFrame:GetName().."Qte");
		local slotFrameQuest = getglobal(slotFrame:GetName().."Quest");
		
		if planque["Slot"][tostring(slot)] then -- On charge le slot
			local slotTab = planque["Slot"][tostring(slot)];
			local objetInfo = TRP2_GetObjectTab(slotTab["ID"]);
			slotFrameIcon:SetTexture("Interface\\ICONS\\"..TRP2_GetWithDefaut(objetInfo,"Icone","Temp"));
			if slotTab["Qte"] > 1 then
				slotFrameQte:SetText(slotTab["Qte"]);
			else
				slotFrameQte:SetText("");
			end
			if TRP2_GetWithDefaut(objetInfo,"bQuest",false) then
				slotFrameQuest:Show();
			else
				slotFrameQuest:Hide();
			end
			slotFrame.ObjetID = slotTab["ID"];
			slotFrame.SlotID = tostring(slot);
			slotFrame.Slot = slotTab;
			slotFrame.TRPtype = "Planque";
			slotFrame.PlanqueID = planqueID;
		else -- Réinitialisation du slot
			slotFrameIcon:SetTexture("");
			slotFrameQte:SetText("");
			slotFrameQuest:Hide();
			slotFrame.ObjetID = nil;
			slotFrame.SlotID = tostring(slot);
			slotFrame.Slot = nil;
			slotFrame.TRPtype = "Planque";
			slotFrame.PlanqueID = nil;
		end
	end
	TRP2InventaireFramePlanque.planqueTab = planque;
	TRP2InventaireFramePlanque.planqueID = planqueID;
	TRP2InventaireFramePlanque.planqueNom = Nom;
	TRP2InventaireFramePlanque:SetScript("OnHide",function()
		if Nom ~= TRP2_Joueur then
			-- Release du lock
			TRP2_SecureSendAddonMessage("PLRL",planqueID,Nom);
		end
	end);
	TRP2InventaireFramePlanque:Show();
end

-- Calcul du tooltip de l'icone de planque
function TRP2_SetPlanquePortraitTooltip(planqueTab,planqueNom)
	if planqueTab then
		local planque = planqueTab;
		local Titre = "{w}|TInterface\\ICONS\\"..TRP2_GetWithDefaut(planque,"Icone","Temp")..".blp:35:35|t "..TRP2_GetWithDefaut(planque,"Nom",TRP2_LOC_NEWPLANQUE);
		local Suite = "{o}"..TRP2_LOC_OWNER.." : "..planqueNom.."\n{v}< "..TRP2_GetWithDefaut(planque,"Continent","").." >\n< "..TRP2_GetWithDefaut(planque,"Zone","").." >\n";
		if TRP2_EmptyToNil(TRP2_GetWithDefaut(planque,"SousZone")) then
			Suite = Suite.."< "..TRP2_GetWithDefaut(planque,"SousZone").." >\n";
		end
		if TRP2_EmptyToNil(TRP2_GetWithDefaut(planque,"NbrSlot")) then
			Suite = Suite.."{o}"..TRP2_LOC_SLOTSUSED.." : "..TRP2_GetWithDefaut(planque,"NbrSlot").."/4\n";
		end
		if TRP2_GetIndexedTabSize(TRP2_GetWithDefaut(planque,"Log",{})) > 0 then
			Suite = Suite.."\n{o}"..GUILD_BANK_LOG.." :\n";
			for _,val in pairs(TRP2_GetWithDefaut(planque,"Log",{})) do
				Suite = Suite.."{w}"..val.."\n";
			end
		end
		if TRP2_EmptyToNil(TRP2_GetWithDefaut(planque,"Lock")) then
			Suite = Suite..TRP2_FT(TRP2_LOC_USEDBY,TRP2_GetWithDefaut(planque,"Lock"));
		end
		Suite = Suite.."\n{w}";
		Suite = Suite..TRP2_LOC_COORD.." :\n< "..TRP2_GetWithDefaut(planque,"CoordX",0).." - "..TRP2_GetWithDefaut(planque,"CoordY",0).." >";
		
		return Titre,Suite;
	end
end

function TRP2_LoadPlanqueList()
	local i = 0; -- Nombre total
	local j = 0; -- Nombre pris
	TRP2_PlanqueListeSlider:Hide();
	TRP2_PlanqueListeSlider:SetValue(0);
	wipe(TRP2_PlanqueList);
	
	for k,v in pairs(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"]) do
		i = i + 1;
		j = j + 1;
		TRP2_PlanqueList[j] = k;
	end
	
	table.sort(TRP2_PlanqueList);

	if j > 0 then
		TRP2_PlanqueListeEmpty:SetText("");
	elseif i == 0 then
		TRP2_PlanqueListeEmpty:SetText(TRP2_LOC_NOPLANQUE);
	else
		TRP2_PlanqueListeEmpty:SetText(TRP2_LOC_SelectVide);
	end
	if j > 42 then
		TRP2_PlanqueListeSlider:Show();
		local total = floor((j-1)/49);
		TRP2_PlanqueListeSlider:SetMinMaxValues(0,total);
	end
	TRP2_PlanqueListeSlider:SetScript("OnValueChanged",function(self)
		if self:IsVisible() then
			TRP2_LoadPlanqueListPage(self:GetValue());
		end
	end)
	TRP2_LoadPlanqueListPage(0);
end

function TRP2_LoadPlanqueListPage(num)
	for k=1,49,1 do --Initialisation
		getglobal("TRP2_PlanqueListeSlot"..k):Hide();
	end
	local i = 1;
	local j = 1;
	table.foreach(TRP2_PlanqueList,
	function(TabIndex)
		if i > num*49 and i <= (num+1)*49 then
			local ID = TRP2_PlanqueList[TabIndex];
			local planqueTab = TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][ID];
			getglobal("TRP2_PlanqueListeSlot"..j):Show();
			getglobal("TRP2_PlanqueListeSlot"..j.."Icon"):SetTexture("Interface\\ICONS\\"..TRP2_GetWithDefaut(planqueTab,"Icone","Temp"));
			getglobal("TRP2_PlanqueListeSlot"..j):SetScript("OnClick", function(self,button)
				TRP2InventaireFramePlanque:Hide();
				TRP2InventaireFramePlanque.planqueTab = planqueTab;
				TRP2InventaireFramePlanque.planqueID = ID;
				if button == "LeftButton" then
					TRP2_EditPlanque(function() TRP2_PlanqueListe:Show() end);
					TRP2_PlanqueListe:Hide();
				else
					TRP2_DeletePlanque(function() TRP2_PlanqueListe:Show() end);
					TRP2_PlanqueListe:Hide();
				end
			end);
			local titre,suite = TRP2_SetPlanquePortraitTooltip(planqueTab,TRP2_Joueur);
			TRP2_SetTooltipForFrame(
				getglobal("TRP2_PlanqueListeSlot"..j),
				getglobal("TRP2_PlanqueListeSlot"..j),"RIGHT",0,0,
				titre,suite.."\n\n{j}"..TRP2_LOC_CLIC.." : {w}"..TRP2_LOC_MODIFPLANQUE.."\n{j}"..TRP2_LOC_CLICDROIT.." : {w}"..TRP2_LOC_DELETEPLANQUE
			);
			j = j + 1;
		end
		i = i + 1;
	end);
end

--**--**--**--**--**--**--**--
-- Planques publiques :
--**--**--**--**--**--**--**--

TRP2_Planques = {};
TRP2_PlanquesLocks = {};
TRP2_ACTIONPLANQUE = nil;

function TRP2_PlanqueAskFunc(func,nom,ID)
	TRP2_ACTIONPLANQUE = func;
	TRP2_SecureSendAddonMessage("PLAS",ID,nom);
end

function TRP2_PlanqueAsk(sender,message)
	if message and TRP2_PlanquesLocks[message] == sender then -- Il faut que le sender aie actuellement le lock
		TRP2_SecureSendAddonMessage("PLOK","",sender);
	else
		TRP2_SecureSendAddonMessage("PLST",message,sender); -- Sinon on le stop
	end
end

function TRP2_PlanqueAskOk(sender)
	if TRP2_ACTIONPLANQUE and sender == TRP2InventaireFramePlanque.planqueNom then
		TRP2_ACTIONPLANQUE();
	end
	TRP2_ACTIONPLANQUE = nil;
end

function TRP2_StartSearchPlanque()
	wipe(TRP2_Planques);
	TRP2InventaireFramePlanque:Hide();
	TRP2_CreationPlanqueFrame:Hide();
	TRP2_SearchPlanqueListe:Show();
	TRP2_LoadSearchPlanqueList();
	local ID = TRP2_GetPlanqueID(true);
	TRP2_SendContentToChannel({ID},"GetPlanque");
end

function TRP2_PlanqueStop(sender,ID)
	if TRP2InventaireFramePlanque:IsVisible() and TRP2InventaireFramePlanque.planqueID == ID then
		TRP2InventaireFramePlanque:Hide();
		TRP2_Afficher(TRP2_FT(TRP2_LOC_ERRORPLANQUE1,sender));
	end
end

function TRP2_SendUpdateLogPlanque(nom,message,ID)
	if TRP2_EmptyToNil(message) then
		TRP2_SecureSendAddonMessage("PLLO",ID..TRP2_ReservedChar..message,nom);
	end
end

function TRP2_GetPlanqueLog(sender,tab)
	if tab[1] and TRP2_PlanquesLocks[tab[1]] == sender then -- Il faut que le sender aie actuellement le lock
		if not TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Log"] then
			TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Log"] = {};
		end
		tinsert(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Log"],1,tab[2]);
		if #TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Log"] > 10 then
			tremove(TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Log"],11);
		end
		TRP2_debug(tab[2]);
	end
end

-- On recois une demande de planque par le channel, et on regarde si on a une planque à cet endroit.
function TRP2_ChanGetPlanque(sender,planqueID)
	-- Est ce que j'ai une planque ici ?
	local planqueTab = TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][planqueID];
	if planqueTab then
		local okAccess = false;
		if not TRP2_GetWithDefaut(planqueTab,"AccessNom") or TRP2_foundInTableString(TRP2_FetchToTabWithSeparator(TRP2_GetWithDefaut(planqueTab,"AccessNom",""),","),sender) then
			--TRP2_debug("Ok AccessNom");
			okAccess = true;
		end
		if okAccess and (TRP2_GetAccess(sender) >= TRP2_GetWithDefaut(planqueTab,"Access",3) or TRP2_GetWithDefaut(planqueTab,"Access",3) == 5)then
			--TRP2_debug("Ok Access");
			okAccess = true;
		end
		if okAccess then
			local Message = planqueID..TRP2_ReservedChar;
			Message = Message..TRP2_GetWithDefaut(planqueTab,"Or","0")..TRP2_ReservedChar;
			Message = Message..TRP2_GetWithDefaut(planqueTab,"Icone","Temp")..TRP2_ReservedChar;
			Message = Message..TRP2_GetIndexedTabSize(TRP2_GetWithDefaut(planqueTab,"Slot",{}))..TRP2_ReservedChar;
			Message = Message..TRP2_GetWithDefaut(planqueTab,"Nom",TRP2_LOC_NEWPLANQUE);
			if TRP2_PlanquesLocks[planqueID] then
				Message = Message..TRP2_ReservedChar..TRP2_PlanquesLocks[planqueID];
			elseif TRP2InventaireFramePlanque:IsVisible() and TRP2InventaireFramePlanque.planqueID == planqueID then
				Message = Message..TRP2_ReservedChar..TRP2_Joueur;
			end
			TRP2_SecureSendAddonMessage("PLSI",Message,sender);
			return;
		end
		TRP2_debug("Pas access !");
	end
end

function TRP2_PlanqueReceiveInfo(sender,planqueTab)
	-- 1 : ID
	-- 2 : Or
	-- 3 : Icone
	-- 4 : Nbr Slot
	-- 5 : Nom
	-- 6 : Lock by
	SetMapToCurrentZone();
	local zoneNum = TRP2_GetCurrentMapZone();
	local continentNum = GetCurrentMapContinent();
	local continents = { GetMapContinents() };
	local x,y = GetPlayerMapPosition("player");
	x = math.floor(x * TRP2_PrecisionPlanque);
	y = math.floor(y * TRP2_PrecisionPlanque);
	local ID = tostring(continentNum).." "..tostring(zoneNum).." "..tostring(x).." "..tostring(y);
	if TRP2_SearchPlanqueListe:IsVisible() and ID == planqueTab[1] then -- Si on a pas bougé
		if TRP2_Planques[sender] then
			wipe(TRP2_Planques[sender]);
		else
			TRP2_Planques[sender] = {};
		end
		TRP2_Planques[sender] = {};
		TRP2_Planques[sender]["Continent"] = continents[continentNum];
		TRP2_Planques[sender]["Zone"] = GetZoneText();
		TRP2_Planques[sender]["SousZone"] = GetSubZoneText();
		TRP2_Planques[sender]["ContinentNum"] = continentNum;
		TRP2_Planques[sender]["ZoneNum"] = zoneNum;
		TRP2_Planques[sender]["Or"] = tonumber(planqueTab[2]);
		TRP2_Planques[sender]["CoordX"] = x;
		TRP2_Planques[sender]["CoordY"] = y;
		TRP2_Planques[sender]["Icone"] = planqueTab[3];
		TRP2_Planques[sender]["NbrSlot"] = tonumber(planqueTab[4]);
		TRP2_Planques[sender]["Slot"] = {};
		TRP2_Planques[sender]["Nom"] = planqueTab[5];
		TRP2_Planques[sender]["ID"] = ID;
		TRP2_Planques[sender]["Lock"] = planqueTab[6];
		TRP2_LoadSearchPlanqueList();
	end
end

function TRP2_PlanqueInitVisit(sender,ID)
	local planqueTab = TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][ID];
	if planqueTab then
		if (not TRP2InventaireFramePlanque:IsVisible() or TRP2InventaireFramePlanque.planqueID ~= ID) and (not TRP2_PlanquesLocks[ID] or TRP2_PlanquesLocks[ID] == sender) then
			TRP2_PlanquesLocks[ID] = sender;
			TRP2_SecureSendAddonMessage("PLSU",ID..TRP2_ReservedChar..TRP2_PlanqueToString(planqueTab),sender);
		else
			TRP2_SecureSendAddonMessage("MESS","TRP2_LOC_ERRORPLANQUE1"..TRP2_ReservedChar..TRP2_Joueur,sender);
		end
	end
end

function TRP2_PlanqueReleaseLock(sender,ID)
	if TRP2_PlanquesLocks[ID] == sender then
		TRP2_PlanquesLocks[ID] = nil;
	end
end

function TRP2_GetUpdateFromPlanque(sender,tab)
	TRP2_debug("Recu : "..tab[1]);
	
	if TRP2_Planques[sender] and TRP2_Planques[sender]["ID"] == tab[1] then
		TRP2_Planques[sender]["Or"] = tonumber(tab[2]);
		TRP2_Planques[sender]["Slot"] = {};
		for i=1,4,1 do
			local ID = TRP2_EmptyToNil(tab[(5*(i-1))+3]);
			if ID then
				TRP2_Planques[sender]["Slot"][tostring(i)] = {};
				TRP2_Planques[sender]["Slot"][tostring(i)]["ID"] = ID;
				TRP2_Planques[sender]["Slot"][tostring(i)]["VerNum"] = tonumber(tab[(5*(i-1))+4]);
				TRP2_Planques[sender]["Slot"][tostring(i)]["Qte"] = tonumber(tab[(5*(i-1))+5]);
				TRP2_Planques[sender]["Slot"][tostring(i)]["Charges"] = tonumber(tab[(5*(i-1))+6]);
				TRP2_Planques[sender]["Slot"][tostring(i)]["LifeTime"] = tonumber(tab[(5*(i-1))+7]);
				TRP2_CheckDoIHaveInfo({ID,TRP2_Planques[sender]["Slot"][tostring(i)]["VerNum"]},sender);
			end
		end
		TRP2_ShowPlanque(sender,tab[1]);
	end
end

function TRP2_SendUpdateToPlanque(sender)
	if sender and TRP2_Planques[sender] then
		TRP2_SecureSendAddonMessage("PLUL",TRP2_Planques[sender]["ID"]..TRP2_ReservedChar..TRP2_PlanqueToString(TRP2_Planques[sender]),sender);
	end
end

function TRP2_GetUpdateFromVisitor(sender,tab)
	TRP2_debug("Recu du visiteur : "..tab[1]);
	if tab[1] and TRP2_PlanquesLocks[tab[1]] == sender then -- Il faut que le sender aie actuellement le lock
		TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Or"] = tonumber(tab[2]);
		TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"] = {};
		for i=1,4,1 do
			local ID = TRP2_EmptyToNil(tab[(5*(i-1))+3]);
			if ID then
				TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"][tostring(i)] = {};
				TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"][tostring(i)]["ID"] = ID;
				TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"][tostring(i)]["VerNum"] = tonumber(tab[(5*(i-1))+4]);
				TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"][tostring(i)]["Qte"] = tonumber(tab[(5*(i-1))+5]);
				TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"][tostring(i)]["Charges"] = tonumber(tab[(5*(i-1))+6]);
				TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"][tostring(i)]["LifeTime"] = tonumber(tab[(5*(i-1))+7]);
				TRP2_CheckDoIHaveInfo({ID,TRP2_Module_Inventaire[TRP2_Royaume][TRP2_Joueur]["Planque"][tab[1]]["Slot"][tostring(i)]["VerNum"]},sender);
			end
		end
	else
		TRP2_SecureSendAddonMessage("PLST",tab[1],sender);
	end
end

-- Transforme un tableau de planque en un string (info des objet + or seulement)
function TRP2_PlanqueToString(planqueTab)
	local message = "";
	message = message..TRP2_GetWithDefaut(planqueTab,"Or",0)..TRP2_ReservedChar;
	local i;
	for i=1,4,1 do
		local Slot = planqueTab["Slot"][tostring(i)];
		if Slot then
			local ID = Slot["ID"];
			local VerNum = TRP2_GetWithDefaut(TRP2_GetObjectTab(ID),"VerNum",1);
			local Qte = Slot["Qte"];
			local Charges = TRP2_NilToEmpty(Slot["Charges"]);
			local LifeTime = TRP2_NilToEmpty(Slot["Lifetime"]);
			message = message..ID..TRP2_ReservedChar..VerNum..TRP2_ReservedChar..Qte..TRP2_ReservedChar..Charges..TRP2_ReservedChar..LifeTime..TRP2_ReservedChar;
		else
			message = message..TRP2_ReservedChar..TRP2_ReservedChar..TRP2_ReservedChar..TRP2_ReservedChar..TRP2_ReservedChar;
		end
	end
	return message;
end

function TRP2_LoadSearchPlanqueList()
	local i = 0; -- Nombre total
	TRP2_SearchPlanqueListeSlider:Hide();
	TRP2_SearchPlanqueListeSlider:SetValue(0);
	wipe(TRP2_PlanqueList);
	
	for k,v in pairs(TRP2_Planques) do
		i = i + 1;
		TRP2_PlanqueList[i] = k;
	end
	
	table.sort(TRP2_PlanqueList);

	if i > 0 then
		TRP2_SearchPlanqueListeEmpty:SetText("");
	elseif i == 0 then
		TRP2_SearchPlanqueListeEmpty:SetText(TRP2_LOC_NOPLANQUEHERE);
	end
	if i > 42 then
		TRP2_SearchPlanqueListeSlider:Show();
		local total = floor((i-1)/49);
		TRP2_SearchPlanqueListeSlider:SetMinMaxValues(0,total);
	end
	TRP2_SearchPlanqueListeSlider:SetScript("OnValueChanged",function(self)
		if self:IsVisible() then
			TRP2_LoadSearchPlanqueListPage(self:GetValue());
		end
	end)
	TRP2_LoadSearchPlanqueListPage(0);
end

function TRP2_LoadSearchPlanqueListPage(num)
	for k=1,49,1 do --Initialisation
		getglobal("TRP2_SearchPlanqueListeSlot"..k):Hide();
	end
	local i = 1;
	local j = 1;
	table.foreach(TRP2_PlanqueList,
	function(TabIndex)
		if i > num*49 and i <= (num+1)*49 then
			local ID = TRP2_PlanqueList[TabIndex]; -- ID = Nom du joueur qui possède la planque
			local planqueTab = TRP2_Planques[ID];
			getglobal("TRP2_SearchPlanqueListeSlot"..j):Show();
			getglobal("TRP2_SearchPlanqueListeSlot"..j.."Icon"):SetTexture("Interface\\ICONS\\"..TRP2_GetWithDefaut(planqueTab,"Icone","Temp"));
			getglobal("TRP2_SearchPlanqueListeSlot"..j):SetScript("OnClick", function()
				TRP2InventaireFramePlanque:Hide();
				TRP2_SearchPlanqueListe:Hide();
				TRP2_SecureSendAddonMessage("PLIN",planqueTab["ID"],ID);
			end);
			local titre,suite = TRP2_SetPlanquePortraitTooltip(planqueTab,ID);
			TRP2_SetTooltipForFrame(
				getglobal("TRP2_SearchPlanqueListeSlot"..j),
				getglobal("TRP2_SearchPlanqueListeSlot"..j),"RIGHT",0,0,
				titre,suite.."\n\n{j}"..TRP2_LOC_CLIC.." : {w}"..TRP2_LOC_OPENPLANQUE
			);
			j = j + 1;
		end
		i = i + 1;
	end);
end
